// rsakg.cpp :      RSA.
//

#include "stdafx.h"
#include <stdio.h>

void main(int argc, char* argv[])
{
	if(argc!=2)
	{
		puts("᪠: rsakg _⥩\n");
		return;
	}		
	HCRYPTPROV hProv;
	if(!CryptAcquireContext(&hProv,argv[1],MS_ENHANCED_PROV,PROV_RSA_FULL,0) && !CryptAcquireContext(&hProv,argv[1],MS_ENHANCED_PROV,PROV_RSA_FULL,CRYPT_NEWKEYSET)) //   keyset   
	{
		puts(" 㤠 ᮧ ⥪\n");
		return;
	}
	HCRYPTKEY hKey;
	if(CryptGenKey(hProv,AT_KEYEXCHANGE,1024<<16,&hKey)) // 1024-   
	{
		RSAPubKey1024 key;
		DWORD dwLen=sizeof(RSAPubKey1024);
		if(CryptExportKey(hKey,NULL,PUBLICKEYBLOB,0,(BYTE *)&key,&dwLen)) // 
		{
			HANDLE hFile;
			if((hFile=CreateFile("pubkey.xch",GENERIC_WRITE,FILE_SHARE_READ,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL))!=INVALID_HANDLE_VALUE)
			{
				if(WriteFile(hFile,&key,dwLen,&dwLen,NULL)) // 
				{
					HCRYPTKEY hKey2;
					if(CryptGenKey(hProv,AT_SIGNATURE,1024<<16,&hKey2)) // 1024-   
					{
						dwLen=sizeof(RSAPubKey1024);
						if(CryptExportKey(hKey2,NULL,PUBLICKEYBLOB,0,(BYTE *)&key,&dwLen)) // 
						{
							HANDLE hFile2;
							if((hFile2=CreateFile("pubkey.sgn",GENERIC_WRITE,FILE_SHARE_READ,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL))!=INVALID_HANDLE_VALUE)
							{
								if(!WriteFile(hFile2,&key,dwLen,&dwLen,NULL)) // 
									puts(" 㤠 ࠭ 㡫  RSA    䠩\n");
								CloseHandle(hFile2);
							}
							else puts(" 㤠 ᮧ 䠩 pubkey.sgn\n");
						}
						else puts(" 㤠 ᯮ஢ 㡫  RSA  \n");
						CryptDestroyKey(hKey2);
					}
					else puts(" 㤠 ᮧ  RSA  \n");
				}
				else puts(" 㤠 ࠭ 㡫  RSA    䠩\n");
				CloseHandle(hFile);
			}
			else puts(" 㤠 ᮧ 䠩 pubkey.xch\n");
		}
		else puts(" 㤠 ᯮ஢ 㡫  RSA  \n");
		CryptDestroyKey(hKey);
	}
	else puts(" 㤠 ᮧ  RSA  \n");
	CryptReleaseContext(hProv,0);
}
