#if !defined(_TOOLS_H__32E06D4B_5085_4E03_8180_58CC1ECA4E6E__INCLUDED_)
#define _TOOLS_H__32E06D4B_5085_4E03_8180_58CC1ECA4E6E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

template<int bitlen> struct RSAPubKey
{
	PUBLICKEYSTRUC  publickeystruc ;
	RSAPUBKEY rsapubkey;
	BYTE modulus[bitlen/8];
};

template<int bitlen> struct RSAPrivKey
{
	RSAPubKey<bitlen> pubkey;
	BYTE prime1[bitlen/16];
	BYTE prime2[bitlen/16];
	BYTE exponent1[bitlen/16];
	BYTE exponent2[bitlen/16];
	BYTE coefficient[bitlen/16];
	BYTE privateExponent[bitlen/8];
};

typedef RSAPubKey<1024> RSAPubKey1024;
typedef RSAPrivKey<1024> RSAPrivKey1024;

template<int bitlen> struct RSAKeyExchBLOB
{
	PUBLICKEYSTRUC publickeystruc ;
	ALG_ID algid;
	BYTE encryptedkey[bitlen/8];
};

typedef RSAKeyExchBLOB<1024> RSA1024KeyExchBLOB;

#endif